import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ThinkInvoiceRequestLog,
  ThinkInvoiceRequestLogParam
} from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkInvoiceRequestLog(
  params: ThinkInvoiceRequestLogParam
) {
  const res = await request.get<ApiResult<PageResult<ThinkInvoiceRequestLog>>>(
    THINK_API_URL + '/think/think-invoice-request-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkInvoiceRequestLog(
  params?: ThinkInvoiceRequestLogParam
) {
  const res = await request.get<ApiResult<ThinkInvoiceRequestLog[]>>(
    THINK_API_URL + '/think/think-invoice-request-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkInvoiceRequestLog(data: ThinkInvoiceRequestLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-request-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkInvoiceRequestLog(
  data: ThinkInvoiceRequestLog
) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-request-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkInvoiceRequestLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-request-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkInvoiceRequestLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-request-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkInvoiceRequestLog(id: number) {
  const res = await request.get<ApiResult<ThinkInvoiceRequestLog>>(
    THINK_API_URL + '/think/think-invoice-request-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
